﻿define([
    "dojo/_base/declare",
    "epi/_Module",
    "epi/shell/command/_Command",
    "epi-cms/plugin-area/assets-pane",
    "epi-cms/command/UploadContent",
    "epi-cms/asset/command/UploadContentToSelection",
    "epi-cms/asset/command/NewFolder",
    "epi-cms/asset/command/RenameSelectedFolder",
    "epi-cms/content-approval/command/EditApprovalDefinition"
], function (
    declare,
    module,
    _Command,
    assetsPanePluginArea,
    UploadContentCommand,
    UploadContentSelectionCommand,
    NewFolder,
    RenameSelectedFolder,
    EditApprovalDefinition
) {
    return declare([module], {

        initialize: function () {
            this.inherited(arguments);
            var getTargetData = function (command) {
                return (command.selection && command.selection.data.length && command.selection.data[0].data) || {};
            };
            var canBeExecute = function (command) {
                return !isScreen9Folder(getTargetData(command))
            };
            var isScreen9Folder = function (model) {
                return model.typeIdentifier && model.typeIdentifier.indexOf('screen9folder') >= 0;
            };
            var UploadOriginal = UploadContentCommand.prototype._onModelChange;
            UploadContentCommand.prototype._onModelChange = function () {
                var result = UploadOriginal.apply(this, arguments);
                if (!this.get('isAvailable')) {
                    return result;
                }

                if (this.viewModel && this.viewModel.name === 'Screen9 Video'
                    && this.model && this.model[0].name === 'Screen9 Video') {
                    this.set('isAvailable', false);
                    this.set('canExecute', false);
                }
                return result;
            };
            var UploadSelOriginal = UploadContentSelectionCommand.prototype._onModelChange;
            UploadContentSelectionCommand.prototype._onModelChange = function () {
                var result = UploadSelOriginal.apply(this, arguments);
                if (!this.get('isAvailable')) {
                    return result;
                }
                if (this.viewModel && this.viewModel.name === 'Screen9 Video'
                    && getTargetData(this).name === 'Screen9 Video') {
                    this.set('isAvailable', false);
                    this.set('canExecute', false);
                }
                return result;
            };
            var RenameOriginal = RenameSelectedFolder.prototype._onModelChange;
            RenameSelectedFolder.prototype._onModelChange = function () {
                var result = RenameOriginal.apply(this, arguments);
                if (!this.get('isAvailable')) {
                    return result;
                }
                if (!canBeExecute(this)) {
                    this.set('isAvailable', false);
                    this.set('canExecute', false);
                }
                return result;
            };
            var NewFolderOriginal = NewFolder.prototype._onModelChange;
            NewFolder.prototype._onModelChange = function () {
                var result = NewFolderOriginal.apply(this, arguments);
                if (!this.get('isAvailable')) {
                    return result;
                }
                if (!canBeExecute(this)) {
                    this.set('isAvailable', false);
                    this.set('canExecute', false);
                }
                return result;
            };
            var EditApprovalDefinitionOriginal = EditApprovalDefinition.prototype._onModelChange;
            EditApprovalDefinition.prototype._onModelChange = function () {
                var result = EditApprovalDefinitionOriginal.apply(this, arguments);
                if (!this.get('isAvailable')) {
                    return result;
                }
                if (isScreen9Folder(this.model)) {
                    this.set('isAvailable', false);
                    this.set('canExecute', false);
                }
                return result;
            };
        }
    });
});
